#!/bin/sh
#set -x

HAL_TEST_REF_FILE="test_loragw_hal"
PKTFWD_TEST_REF_FILE="basic_pkt_fwd"
# get the path to generate the customized json
HAL_TEST_DIR=`find ./ -name $HAL_TEST_REF_FILE -type f | awk -F\/ '{print $4}'`
PKT_FWD_DIR=`find ./ -name $PKTFWD_TEST_REF_FILE -type f | awk -F\/ '{print $4}'`
CALIBRATION=$(grep rssi_offset ./mnt/fsuser-1/loraboard_conf.json | tail -1 | cut -d: -f2)

if [ $CALIBRATION != 0.0 ]
then

# customize the json file with calibration parameters
cp ./mnt/fsuser-1/loraboard_conf.json ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json

sed -i '/SX1301_conf/ a\                "clksrc": 1,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/SX1301_conf/ a\                "lorawan_public":true,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json

sed -i '/radio_0/ a\                        "freq": 867500000,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/radio_0/ a\                        "type": "SX1257",' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/radio_0/ a\                        "enable":true,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/radio_0/ a\                        "tx_enable": true,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json

sed -i '/radio_1/ a\                        "freq": 868500000,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/radio_1/ a\                        "type": "SX1257",' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/radio_1/ a\                        "enable":true,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
sed -i '/radio_1/ a\                        "tx_enable": false,' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json

sed -i '/tx_lut_0/ i\
                "chan_multiSF_0": { \
			/* Lora MAC channel, 125kHz, all SF, 868.1 MHz */ \
			"enable": true, \
			"radio": 1, \
			"if": -400000 \
		}, \
		"chan_multiSF_1": { \
			/* Lora MAC channel, 125kHz, all SF, 868.3 MHz */ \
			"enable": true, \
			"radio": 1, \
			"if": -200000 \
		}, \
		"chan_multiSF_2": { \
			/* Lora MAC channel, 125kHz, all SF, 868.5 MHz */ \
			"enable": true, \
			"radio": 1, \
			"if": 0 \
		}, \
		"chan_multiSF_3": { \
			/* Lora MAC channel, 125kHz, all SF, 867.1 MHz */ \
			"enable": true, \
			"radio": 0, \
			"if": -400000 \
		}, \
		"chan_multiSF_4": { \
			/* Lora MAC channel, 125kHz, all SF, 867.3 MHz */ \
			"enable": true, \
			"radio": 0, \
			"if": -200000 \
		}, \
		"chan_multiSF_5": { \
			/* Lora MAC channel, 125kHz, all SF, 867.5 MHz */ \
			"enable": true, \
			"radio": 0, \
			"if": 0 \
		}, \
		"chan_multiSF_6": { \
			/* Lora MAC channel, 125kHz, all SF, 867.7 MHz */ \
			"enable": true, \
			"radio": 0, \
			"if": 200000 \
		}, \
		"chan_multiSF_7": { \
			/* Lora MAC channel, 125kHz, all SF, 867.9 MHz */ \
			"enable": true, \
			"radio": 0, \
			"if": 400000 \
		}, \
		"chan_Lora_std": { \
			/* Lora MAC channel, 250kHz, SF7, 868.3 MHz */ \
			"enable": true, \
			"radio": 1, \
			"if": -200000, \
			"bandwidth": 250000, \
			"spread_factor": 7 \
		}, \
		"chan_FSK": { \
			/* FSK 50kbps channel, 868.8 MHz */ \
			"enable": true, \
			"radio": 1, \
			"if": 300000, \
			"bandwidth": 125000, \
			"datarate": 50000 \
                }, ' ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json

				
# customize the json file
cp ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json

sed -i '$d' ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
sed -i '$d' ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
sed -i '/gateway_ID/ s/.*/&,/' ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "              \"serv_port_up\": 1680,"			>> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "              \"serv_port_down\": 1680,"			>> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "              \"server_address\": \"iot.semtech.com\""    >> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "  }"                                                      >> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "}"                                                        >> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json

cp ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json ./mnt/fsuser-1/${PKT_FWD_DIR}/basic_pkt_fwd/
cp ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json ./mnt/fsuser-1/${PKT_FWD_DIR}/gps_pkt_fwd/

else

MAC_ADDR_COMMON="024b08"
KNET_ID=$(get_uvar ethaddr | awk -F\: '{print tolower($4$5$6)}')
MAC_ADDR=${MAC_ADDR_COMMON}${KNET_ID}

# customize the json file with gateway MAC address, can only be done on-the-fly

echo "{"                                              > ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
echo "  \"gateway_conf\": {"                         >> ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
echo "      \"gateway_ID\": \"0000${MAC_ADDR}\" "    >> ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
echo "  }"                                           >> ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json
echo "}"                                             >> ./mnt/fsuser-1/${HAL_TEST_DIR}/util_pkt_logger/local_conf.json


echo "{"                                              	> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "  \"gateway_conf\": {"                         	>> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "      \"gateway_ID\": \"0000${MAC_ADDR}\", "	>> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "      \"serv_port_up\": 1680," 			>> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "      \"serv_port_down\": 1680,"			>> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "      \"server_address\": \"iot.semtech.com\" ">> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "  }"                                           >> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json
echo "}"                      			     >> ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json

cp ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json ./mnt/fsuser-1/${PKT_FWD_DIR}/basic_pkt_fwd/
cp ./mnt/fsuser-1/${PKT_FWD_DIR}/beacon_pkt_fwd/local_conf.json ./mnt/fsuser-1/${PKT_FWD_DIR}/gps_pkt_fwd/

fi
#set +x
